/*
SD / MMC Bootloader for Atmel Atmega microcontrollers

Author:
	Nik Bamert
	nikbamert@bluewin.ch / admin@nikbamert.com
	www.nikbamert.com
	
License:	
	Creative Commons : Attribution-NonCommercial 2.5
	
	You are free:
	
		* to copy, distribute, display, and perform the work
		* to make derivative works
	
	Under the following conditions:
		
	Attribution. You must attribute the work in the manner specified by the author or licensor.
		
	Noncommercial. You may not use this work for commercial purposes.
	
		* For any reuse or distribution, you must make clear to others the license terms of this work.
		* Any of these conditions can be waived if you get permission from the copyright holder.
	
	Your fair use and other rights are in no way affected by the above.
	
	This is a human-readable summary of the Legal Code (the full license). 
	
	http://creativecommons.org/licenses/by-nc/2.5/legalcode
*/

#define BPB_RsvdSecCnt 	0x0E 
#define BPB_NumFATs 	0x10
#define BPB_SECperFat	0x24
#define BPB_SecPerClus	0x0D
#define BPB_RootClus 	0x2C
#define PARTITION_TYPE 450


#define FAT_OK 0x00
#define ERROR_NO_FAT 0x01
#define NO_FREE_FILEHANDLES 0x01
#define FILE_FOUND 0x10
#define FILE_NOT_FOUND 0x02
#define FATAL_ERROR 0x20

#define FAT16 1
#define FAT32 2

#define FILE_CLOSED 0

#define FIRMWARE_FILE 0
struct {
    unsigned char partitiontype;
	unsigned char secsperclus; 
    unsigned long fatbegin;  // 16 BIT  Sollwert Steuerspannung
	unsigned long clusbegin;

	
}Filesystem;


struct{
	unsigned long startcluster;
	unsigned long size;
}files;

unsigned char buffer[512];

void FAT_ReadSector(uint32_t sector);
extern uint8_t fat_init(void);
uint32_t followClusterChain(unsigned long cluster);
extern uint8_t fopen(unsigned char *filename);
extern uint32_t fprogram(uint8_t handle);
